## Benchmark

### Rack: hello world

Create a aws `t2.xlarge` machine.

Use `rackup` to start server.

```ruby
#\ -s soba -q -O Port=3000

require 'soba/server'

# apply green threads monkey patch before application load
require 'soba/monkey'
Soba::Monkey.patch!

app = proc do |env|
  [ 200, {'Content-Type' => 'text/plain'}, ["你好，世界"] ]
end

run app
```

run `wrk -t12 -c400 -d30s http://127.0.0.1:3000/`

```
  Soba:
  Running 30s test @ http://127.0.0.1:3000/
    12 threads and 400 connections
    Thread Stats   Avg      Stdev     Max   +/- Stdev
      Latency    62.35ms   18.20ms 467.83ms   98.53%
      Req/Sec   185.17     77.31   660.00     77.91%
    65904 requests in 30.06s, 6.10MB read
  Requests/sec:   2192.15
  Transfer/sec:    207.65KB
  
  Falcon:
  Running 30s test @ http://127.0.0.1:3000/
    12 threads and 400 connections
    Thread Stats   Avg      Stdev     Max   +/- Stdev
      Latency   115.32ms   28.54ms   1.09s    96.18%
      Req/Sec   284.39     83.47   666.00     83.16%
    102006 requests in 30.04s, 9.24MB read
    Socket errors: connect 0, read 0, write 0, timeout 1
  Requests/sec:   3395.81
  Transfer/sec:    315.04KB

  Puma:
  Running 30s test @ http://127.0.0.1:3000/
    12 threads and 400 connections
    Thread Stats   Avg      Stdev     Max   +/- Stdev
      Latency     7.34ms   10.55ms 104.94ms   86.40%
      Req/Sec     1.10k   441.58     2.00k    56.57%
    65568 requests in 30.10s, 6.13MB read
  Requests/sec:   2178.59
  Transfer/sec:    208.50KB
  
  Thin:
  Running 30s test @ http://127.0.0.1:3000/
    12 threads and 400 connections
    Thread Stats   Avg      Stdev     Max   +/- Stdev
      Latency    46.76ms   81.43ms   1.11s    98.09%
      Req/Sec   322.11    239.56     0.97k    64.13%
    29674 requests in 30.07s, 3.71MB read
    Socket errors: connect 359, read 0, write 0, timeout 10
  Requests/sec:    986.78
  Transfer/sec:    126.24KB
```