require 'rack/handler'
require 'soba/server'

module Rack
  module Handler
    module Soba
      DEFAULT_OPTIONS = {
        :debug => false,
      }


      def self.run(app, options = {})
        options = DEFAULT_OPTIONS.merge(options)

        host, port = options[:Host], options[:Port]

        server = ::Soba::Server.new(app, host: host, port: port, **options)

        yield server if block_given?
        begin
          server.run
        rescue Interrupt
          puts "* Stopping..."
          # server.stop
          puts "* Cool!"
        end
      end

      def self.valid_options
        {
          "Host=HOST" => "Hostname to listen on (default: localhost)",
          "Port=PORT" => "Port to listen on (default: 8080)",
          "debug=false" => "Enable debug output (default: false)",
        }
      end
    end

    register :soba, Soba
  end
end
